DROP TYPE USR_EXIBE_EMBALAGEM_OL_TABLE
/

DROP TYPE USR_EXIBE_EMBALAGEM_OL_TYPE
/

CREATE TYPE USR_EXIBE_EMBALAGEM_OL_TYPE AS
OBJECT(CDARVPROD     VARCHAR2(10),
       NMPRODUTO     VARCHAR2(50),
       SGUNIDADE     VARCHAR2(10),
       VRFATOCONV    FLOAT,
       VRARREDCMP    FLOAT,
       CDPRODUTO     VARCHAR2(10),
       QTPROGENPEOL  FLOAT)
/

CREATE TYPE USR_EXIBE_EMBALAGEM_OL_TABLE AS TABLE OF USR_EXIBE_EMBALAGEM_OL_TYPE
/

CREATE OR REPLACE FUNCTION USR_EXIBE_EMBALAGEM_OL(P_CDMARCA      IN VARCHAR2,
                                                  P_CDPRODUTO    IN VARCHAR2,
                                                  P_QTPROGENPEOL IN FLOAT) RETURN USR_EXIBE_EMBALAGEM_OL_TABLE PIPELINED
IS
  TYPE CURTYPE            IS REF CURSOR;
  C_ITENS                 CURTYPE;
  V_CDPRODARVOL           RELACPRODOL.CDPRODARVOL%TYPE;
  V_ITENS_CDPRODUTO       PRODUTO.CDPRODUTO%TYPE;
  V_ITENS_NMPRODUTO       PRODUTO.NMPRODUTO%TYPE;
  V_ITENS_CDARVPROD       PRODUTO.CDARVPROD%TYPE;
  V_ITENS_SGUNIDADE       PRODUTO.SGUNIDADE%TYPE;
  V_ITENS_VRFATOCONV      PRODUTO.VRFATOCONV%TYPE;
  V_ITENS_VRARREDCMP      PRODUTO.VRARREDCMP%TYPE;
  V_ITENS_QTPROGENPEOL    ITEMPEDEXOL.QTPROGENPEOL%TYPE;
  V_CONTADOR              ITEMPEDEXOL.QTPROGENPEOL%TYPE := 0;
  V_CONTADORAUX           ITEMPEDEXOL.QTPROGENPEOL%TYPE := 0;
  V_QTDEPRODUTO           ITEMPEDEXOL.QTPROGENPEOL%TYPE := 0;
  V_QTDERESTANTE          ITEMPEDEXOL.QTPROGENPEOL%TYPE := 0;
  V_QTDERESTANTE1         ITEMPEDEXOL.QTPROGENPEOL%TYPE := 0;
  V_QTPROGENPEOL          ITEMPEDEXOL.QTPROGENPEOL%TYPE := 0;


  OUT_RECORD USR_EXIBE_EMBALAGEM_OL_TYPE := USR_EXIBE_EMBALAGEM_OL_TYPE (NULL, NULL, NULL,
                                                                         0, 0, NULL, 0);
BEGIN
   SELECT NVL(MAX(CDPRODARVOL), '')
     INTO V_CDPRODARVOL
     FROM RELACPRODOL
    WHERE CDPRARVORIG = P_CDPRODUTO
      AND CDMARCA     = P_CDMARCA;
   V_QTPROGENPEOL := P_QTPROGENPEOL;
   IF (V_CDPRODARVOL <> '') AND (V_QTPROGENPEOL > 0) THEN
      V_QTDERESTANTE  := P_QTPROGENPEOL;
      V_QTDERESTANTE1 := P_QTPROGENPEOL;
      OPEN C_ITENS FOR
         SELECT PRODUTO.CDPRODUTO, PRODUTO.NMPRODUTO, PRODUTO.CDARVPROD,
                PRODUTO.SGUNIDADE, CASE NVL(PRODUTO.VRFATOCONV, 1)
                                      WHEN 0
                                      THEN 1
                                      ELSE NVL(PRODUTO.VRFATOCONV, 1)
                                   END VRFATOCONV,
                                   CASE NVL(PRODUTO.VRARREDCMP, 1)
                                      WHEN 0
                                      THEN 1
                                      ELSE NVL(PRODUTO.VRARREDCMP, 1)
                                   END VRARREDCMP
           FROM PRODUTO, PRODUTO PRODUTOOL
          WHERE PRODUTOOL.CDPRODUTO = V_CDPRODARVOL
            AND PRODUTO.CDPRODESTO  = PRODUTOOL.CDPRODESTO
          ORDER BY CASE NVL(PRODUTO.VRFATOCONV, 1)
                                      WHEN 0
                                      THEN 1
                                      ELSE NVL(PRODUTO.VRFATOCONV, 1)
                                   END *
                                   CASE NVL(PRODUTO.VRARREDCMP, 1)
                                      WHEN 0
                                      THEN 1
                                      ELSE NVL(PRODUTO.VRARREDCMP, 1)
                                   END DESC;
      LOOP
      FETCH C_ITENS INTO V_ITENS_CDPRODUTO, V_ITENS_NMPRODUTO, V_ITENS_CDARVPROD,
                         V_ITENS_SGUNIDADE, V_ITENS_VRFATOCONV, V_ITENS_VRARREDCMP;
         IF V_ITENS_CDPRODUTO IS NOT NULL THEN
            SELECT NVL(MAX(CDARVPROD), V_ITENS_CDARVPROD), NVL(MAX(NMPRODUTO), V_ITENS_NMPRODUTO)
              INTO V_ITENS_CDARVPROD, V_ITENS_NMPRODUTO
              FROM PRODUTO, RELACPRODOL
             WHERE RELACPRODOL.CDPRARVORIG = PRODUTO.CDPRODUTO
               AND RELACPRODOL.CDPRODARVOL = V_ITENS_CDPRODUTO;
            IF V_ITENS_VRARREDCMP > 0 THEN
               V_CONTADOR := V_ITENS_VRARREDCMP;
            ELSE
               V_CONTADOR := 1;
            END IF;
            V_QTDEPRODUTO     := 0;
            IF C_ITENS%NOTFOUND THEN
               WHILE (V_QTDERESTANTE > 0) LOOP
                  V_QTDEPRODUTO := V_CONTADOR;
                  V_QTDERESTANTE:= V_QTPROGENPEOL - (V_ITENS_VRFATOCONV*V_CONTADOR);
                  IF V_ITENS_VRARREDCMP > 0 THEN
                     V_CONTADOR := V_CONTADOR + V_ITENS_VRARREDCMP;
                  ELSE
                     V_CONTADOR := V_CONTADOR + 1;
                  END IF;
                  V_CONTADORAUX := V_CONTADORAUX + 1;
               END LOOP;
               IF (V_CONTADORAUX > 0) THEN
                  V_CONTADORAUX := 0;
                  V_QTDERESTANTE           := V_QTPROGENPEOL - (V_QTDEPRODUTO*V_ITENS_VRFATOCONV);
                  V_QTPROGENPEOL           := V_QTDERESTANTE;
                  IF (V_QTDEPRODUTO > 0) THEN
                     OUT_RECORD.CDARVPROD     := V_ITENS_CDARVPROD;
                     OUT_RECORD.NMPRODUTO     := V_ITENS_NMPRODUTO;
                     OUT_RECORD.SGUNIDADE     := V_ITENS_SGUNIDADE;
                     OUT_RECORD.VRFATOCONV    := V_ITENS_VRFATOCONV;
                     OUT_RECORD.VRARREDCMP    := V_ITENS_VRARREDCMP;
                     OUT_RECORD.CDPRODUTO     := V_ITENS_CDPRODUTO;
                     OUT_RECORD.QTPROGENPEOL  := V_QTDEPRODUTO;
                     PIPE ROW (OUT_RECORD);
                  END IF;
               END IF;
               EXIT WHEN C_ITENS%NOTFOUND;
            ELSE
               WHILE (V_QTDERESTANTE > 0) LOOP
                  V_QTDEPRODUTO := V_CONTADOR;
                  V_QTDERESTANTE:= V_QTPROGENPEOL - (V_ITENS_VRFATOCONV*V_CONTADOR);
                  IF V_ITENS_VRARREDCMP > 0 THEN
                     V_CONTADOR := V_CONTADOR + V_ITENS_VRARREDCMP;
                  ELSE
                     V_CONTADOR := V_CONTADOR + 1;
                  END IF;
                  V_CONTADORAUX := V_CONTADORAUX + 1;
                  IF  (V_QTPROGENPEOL < (V_QTDEPRODUTO*V_ITENS_VRFATOCONV)) AND
                      (V_QTDEPRODUTO > 0) THEN
                     V_QTDEPRODUTO := V_QTDEPRODUTO - 1;
                  END IF;
               END LOOP;
               IF (V_CONTADORAUX > 0) THEN
                  V_CONTADORAUX := 0;
                  V_QTDERESTANTE           := V_QTPROGENPEOL - (V_QTDEPRODUTO*V_ITENS_VRFATOCONV);
                  V_QTPROGENPEOL           := V_QTDERESTANTE;
                  IF (V_QTDEPRODUTO > 0) THEN
                     OUT_RECORD.CDARVPROD     := V_ITENS_CDARVPROD;
                     OUT_RECORD.NMPRODUTO     := V_ITENS_NMPRODUTO;
                     OUT_RECORD.SGUNIDADE     := V_ITENS_SGUNIDADE;
                     OUT_RECORD.VRFATOCONV    := V_ITENS_VRFATOCONV;
                     OUT_RECORD.VRARREDCMP    := V_ITENS_VRARREDCMP;
                     OUT_RECORD.CDPRODUTO     := V_ITENS_CDPRODUTO;
                     OUT_RECORD.QTPROGENPEOL  := V_QTDEPRODUTO;
                     PIPE ROW (OUT_RECORD);
                  END IF;
               END IF;
            END IF;
         ELSE
            EXIT WHEN C_ITENS%NOTFOUND;
         END IF;
      END LOOP;
      CLOSE C_ITENS;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXIBE_EMBALAGEM_OL','6.05.000'); END;
/

